SUBROUTINE BK_PROJ

  USE GLOBAL, ONLY: INP_FILE, OUT_FILE, V, IDEC, DEC, N, TB, DT, NITER
  USE nrtype
  USE NR
  USE xlinbcg_data
!----------------------------------------------------------------------

  IMPLICIT NONE

  CHARACTER (LEN=10)  :: TLBUF

  INTEGER             :: I, J, K

  REAL (DP), DIMENSION(:), ALLOCATABLE :: GJ, T

  INTEGER(I4B), PARAMETER :: ITOL=1,ITMAX=75
	REAL(DP)    , PARAMETER :: TOL=1.e-9_dp
	INTEGER(I4B) :: iter
	REAL(DP)     :: err, G, TP, TL, TK, TM
	REAL(DP), DIMENSION(:)  , ALLOCATABLE :: B, X
	REAL(DP), DIMENSION(:,:), ALLOCATABLE :: A
	
!----------------------------------------------------------------------

  ALLOCATE ( T(N), GJ(N), B(NITER), X(NITER), A(NITER,NITER) )

  OPEN  ( 20, FILE = 'BOOK.NEW', STATUS = 'NEW' )
  WRITE ( 20, '(A)' ) '   N  |<RnF,G_gama,fi>|   scale [s]   |  positio&
               &n [s] | frequency [Hz]|    Fi [rad]   |   K_gamma,fi  '
  WRITE ( 20, '(A)' ) ' -----+---------------+---------------+---------&
               &------+---------------+---------------+---------------'
  CLOSE ( 20 )

  DO J = 1, NITER

    B(J) = 0._DP

    WRITE ( TLBUF, '(A3, I3.3, A4)' )  'VEC', IDEC(J), '.DAT'
    OPEN  ( 20, FILE = TLBUF(1:10), STATUS = 'OLD' )
    
    DO I = 1, N
      READ ( 20, *) T(I), GJ(I)
      GJ(I) = GJ(I)/DEC(J,0)
      B (J) = B(J) + GJ(I)*V(I)
    END DO
    
    CLOSE ( 20 )

    DO K = J, NITER

      A(J,K) = 0._DP

      WRITE ( TLBUF, '(A3, I3.3, A4)' )  'VEC', IDEC(K), '.DAT'
      OPEN  ( 20, FILE = TLBUF(1:10), STATUS = 'OLD' )
      DO I = 1, N
        READ ( 20, *) T(I), G
        A(J,K) = A(J,K) + GJ(I)*G/DEC(K,0)
      END DO
      CLOSE ( 20 )
      A(K,J)=A(J,K)

    END DO

  END DO

  CALL SPRSIN (A,1.e-6_dp,SA)
	X = 0.0_DP
	CALL LINBCG (B,X,ITOL,TOL,ITMAX,ITER,ERR)

  V = 0._DP

  DO J = 1, NITER

    WRITE ( TLBUF, '(A3, I3.3, A4)' )  'VEC', IDEC(J), '.DAT'
    OPEN  ( 20, FILE = TLBUF(1:10), STATUS = 'OLD' )
    
    DO I = 1, N
      READ ( 20, *) T(I), GJ(I)
    END DO
    
    CLOSE ( 20 )

    GJ = GJ/DEC(J,0)
    DEC(J,0) = DEC(J,0) + X(J)
    GJ = GJ*DEC(J,0)

    WRITE ( TLBUF, '(A2, I3.3, A4)' )  'VN', J, '.DAT'
    OPEN  ( 20, FILE = TLBUF(1:9), STATUS = 'NEW' )
    
    DO I = 1, N
      WRITE ( 20, *) T(I), GJ(I)
      V(I) = V(I) + GJ(I)
    END DO
    
    CLOSE ( 20 )

    OPEN  ( 20, FILE = 'BOOK.NEW', STATUS = 'UNKNOWN',                 &
                POSITION = 'APPEND' )
    TP = DEC(J,2)*DT
    TK = DEC(J,3)/DT/REAL(N,DP)
    TL = DEC(J,6)/DT/DT/REAL(N,DP)
    TM = DEC(J,7)/DT/DT/DT/REAL(N,DP)
    WRITE ( 20, '(1X, I5, 8(1X, G15.6))' ) J,                          &
                                           DEC(J,0),                   &
                                           DEC(J,1)*DT,                &
                                           TP+TB,                      &
                                           TK+TL*TP,                   &
                                           DEC(J,4),                   &
                                           DEC(J,5),                   &
                                           TL+TM*TP,                   &
                                           3.*TM
    CLOSE ( 20 )

  END DO

  OPEN  ( 20, FILE = OUT_FILE, STATUS = 'NEW' )
  
  DO I = 1, N
    WRITE ( 20, *) T(I), V(I)
  END DO
  
  CLOSE ( 20 )

  OPEN  ( 20, FILE = INP_FILE, STATUS = 'OLD' )
  OPEN  ( 15, FILE = 'VNRES.DAT', STATUS = 'NEW' )
  
  DO I = 1, N
    READ  ( 20, *) G
    WRITE ( 15, *) T(I), G-V(I)
  END DO
  
  CLOSE ( 20 )
  CLOSE ( 15 )

END SUBROUTINE BK_PROJ

