FUNCTION EF (T, W)

  USE GLOBAL, ONLY: DP, PI2, N, TB, DT, DEC, NITER, WG

!----------------------------------------------------------------------

  IMPLICIT NONE

  REAL (DP), INTENT(IN) :: T, W
  REAL (DP)             :: EF

  INTEGER   :: I, NUM
  REAL (DP) :: S, P, K, L, M, W1

!----------------------------------------------------------------------

  EF = 0._DP
  DO I = 1, NITER
    P = DEC(I,2)*DT+TB
    K = DEC(I,3)*PI2/REAL(N,DP)/DT
    L = DEC(I,6)*PI2/REAL(N,DP)/DT/DT
    M = DEC(I,7)*PI2/REAL(N,DP)/DT/DT/DT
    IF      ( NINT(DEC(I,1)) >= 2*N ) THEN
      S = DEC(I,1)*DT
      W1 = (3.*M*T*T-4.*M*T*P+M*P*P+2.*L*T-L*P+K)
      EF = EF + DEC(I,0)*DEC(I,0)                                    &
           * ( WG ( 0._DP, S*(W-W1 ) ) )
    ELSE IF ( NINT(DEC(I,1)) == 1   ) THEN
      S = DEC(I,1)*DT
      EF = EF + DEC(I,0)*DEC(I,0)                                      &
         * ( WG ( (T-P)/S, 0._DP ) )
    ELSE
      S = DEC(I,1)*DT
      W1 = (3.*M*T*T-4.*M*T*P+M*P*P+2.*L*T-L*P+K)
      EF = EF + DEC(I,0)*DEC(I,0)                                    &
           * ( WG ( (T-P)/S, S*(W-W1 ) ) )
    END IF
  END DO

END FUNCTION EF