SUBROUTINE READ_INP_PARAM

  USE GLOBAL, ONLY: INP_FILE, OUT_FILE, TB, TE, DT, FMAX, KEY_LOG,     &
                    OFMAX, FMIN, DICT

!-----------------------------------------------------------------------

  IMPLICIT NONE

  INTEGER :: NT, NF
                                                                  
  NAMELIST /CONTROL_DATA/ INP_FILE, OUT_FILE, TB, TE, DT, FMIN, FMAX,  &
                          NT, NF, KEY_LOG, DICT

!-----------------------------------------------------------------------
  KEY_LOG = .FALSE.
  FMIN    = -1.
  FMAX    = -1.
  NF      = 500
  DICT    = 999    ! 1 - original, 2 - linear, 3 - quadratic 

  OPEN  ( 10, FILE="HFBK2WG", STATUS="OLD" )
  READ  ( 10, NML=CONTROL_DATA )

  IF ( DICT > 900 ) THEN
    print *, ' The value of parameter "DICT" (type of used dictionary) '
    print *, ' in the file "HFBK2WG" is missing !!! '
    print *, ' (1 - original, 2 - linear, 3 - quadratic) '
    STOP
  ENDIF


  IF ( FMAX < 0. ) THEN
    FMAX = 0.5/DT
  END IF

  IF ( FMIN < 0. ) THEN
    IF ( KEY_LOG ) THEN
      FMIN = FMAX/1000.
    ELSE
      FMIN = 0.
    END IF
  END IF

  CLOSE ( 10 )

  INP_FILE  = INP_FILE (1:LEN_TRIM(INP_FILE))//'.DAT'

  OFMAX = NF
  
END SUBROUTINE READ_INP_PARAM

