SUBROUTINE WIGNER

  USE PRECISION

  USE GLOBAL, ONLY: DP, PI2, WV, N, DT, TB, DF, OFMAX, EF, KEY_LOG,   &
                    FMAX, FMIN

!----------------------------------------------------------------------

  IMPLICIT NONE
  
  INTEGER :: IT, IW
  REAL(DP)::  T,  W, FMAXLOG, FMINLOG

!----------------------------------------------------------------------
  IF (KEY_LOG) THEN
    FMAXLOG = LOG10 (FMAX)
    FMINLOG = LOG10 (FMIN)
  ENDIF
  
  DO IT = 1, N
    DO IW = 1, OFMAX
      T = REAL(IT-1,DP)*DT+TB
      IF (KEY_LOG) THEN
        W = (10**( REAL(IW-1,DP)/REAL(OFMAX-1,DP)*(FMAXLOG-FMINLOG) + FMINLOG))*PI2
      ELSE
        W = (      REAL(IW-1,DP)/REAL(OFMAX-1,DP)*(FMAX   -FMIN   ) + FMIN    )*PI2
      ENDIF
      WV(IT,IW) = EF(T,W)
    END DO
  END DO
  WV(N+1,:) = 1._DP

END SUBROUTINE WIGNER