FUNCTION C_FUNC (x)

  USE GLOBAL, ONLY: RV, INN_PROD, FIND_KS, G_GAMA, PI2, GG, N
  USE NRTYPE

  IMPLICIT NONE

  INTEGER     :: I 
  COMPLEX(DP) :: C_FUNC
  REAL   (SP), DIMENSION(:), INTENT(IN) :: x
  REAL   (DP) :: S, P, K, L, M, KS, T, RI

  S      = REAL ( X(1), DP )
  P      = REAL ( X(2), DP )
  K      = REAL ( X(3), DP )
  L      = REAL ( X(4), DP )
  M      = REAL ( X(5), DP )
  KS     = FIND_KS ( S )

  IF ( NINT(S) >= 2*N ) THEN
    DO I = 1, N
      RI = REAL(I,DP)
      T = RI-P
      GG (I) = KS * EXP( CMPLX(0._DP,PI2)*(M*T*T+L*T+K)*RI/REAL(N,DP) )
    END DO
  ELSE
    DO I = 1, N
      GG (I) = G_GAMA ( S, P, K, L, M, I, KS )
    END DO
  END IF

  C_FUNC = INN_PROD ( RV, GG )

END FUNCTION C_FUNC
