MODULE  GLOBAL

  USE PRECISION

  IMPLICIT NONE

  CHARACTER (LEN=1)   :: TYPE_D
  CHARACTER (LEN=10)  :: INP_FILE

  INTEGER             :: N, NITER, L2N, NN, OFMAX

  REAL(DP)            :: TB, TE, DT, EPSILON

  REAL   (DP) ,DIMENSION (:),   ALLOCATABLE :: V
  COMPLEX(DP) ,DIMENSION (:),   ALLOCATABLE :: RV, GG

  REAL   (DP) ,DIMENSION (:,:), ALLOCATABLE :: DEC, WV

  INTERFACE

    FUNCTION     C_FUNC (x)
      USE nrtype
      IMPLICIT NONE
      COMPLEX(DP) :: C_FUNC
      REAL   (SP), DIMENSION(:), INTENT(IN) :: x
    END FUNCTION C_FUNC

    FUNCTION     FIND_KS (S)
      USE PRECISION, ONLY: DP
      IMPLICIT NONE
      REAL (DP), INTENT(IN) :: S
      REAL (DP)             :: FIND_KS
    END FUNCTION FIND_KS

    FUNCTION     G (T)
      USE PRECISION, ONLY: DP
      IMPLICIT NONE
      REAL (DP), INTENT(IN) :: T
      REAL (DP)             :: G
    END FUNCTION G

    FUNCTION     GS ( S, I, KS )
      USE PRECISION, ONLY: DP
      IMPLICIT NONE
      REAL (DP), INTENT(IN) :: S, KS, I
      REAL (DP)             :: GS
    END FUNCTION GS

    FUNCTION     G_GAMA (S, P, K, L, M, I, KS)
      USE PRECISION, ONLY: DP
      IMPLICIT NONE
      INTEGER     , INTENT(IN) :: I
      REAL    (DP), INTENT(IN) :: KS, S, P, K, L, M
      COMPLEX (DP)             :: G_GAMA
    END FUNCTION G_GAMA

    FUNCTION     INN_PROD (RV, GG)
      USE PRECISION, ONLY: DP
      IMPLICIT NONE
      COMPLEX (DP), DIMENSION(:), INTENT(IN) :: RV, GG
      COMPLEX (DP)                           :: INN_PROD
    END FUNCTION INN_PROD

    FUNCTION     FUNC_ALFA (GS_ALFA, P, K, L, M)
      USE PRECISION, ONLY: DP
      IMPLICIT NONE
      REAL    (DP)              , INTENT(IN) :: P, K, L, M
      REAL    (DP), DIMENSION(:), INTENT(IN) :: GS_ALFA
      REAL    (DP)                           :: FUNC_ALFA
    END FUNCTION FUNC_ALFA


  END INTERFACE

END MODULE  GLOBAL