SUBROUTINE READ_INP_PARAM

  USE GLOBAL, ONLY: WVLT_TYPE, INP_FILE, OUTo_FILE, OUTr_FILE, OUTt_FILE,&
                    TB, TE, DT, OFMAX, FMIN, FMAX, PCOI, KEY_LOG,        &
                    K1, K2, K3, K4, KNFFT, NFFT, NFFT21, WVD, WVT,       &
                    V, WV, F_V, FWV, FPWV, TTT, FFF, W0, M, N, OUTf_FILE

  IMPLICIT NONE  

  INTEGER :: NT, NF

!----------------------------------------------------------------------
                                                                  
  NAMELIST /CONTROL_DATA/ INP_FILE, WVLT_TYPE, TB, TE, DT, NT,        &
                          NF, FMIN, FMAX, PCOI, K1, K2, K3, K4,       &
                          KEY_LOG, KNFFT
  NAMELIST /TYPE_1/       W0
  NAMELIST /TYPE_2/       M
  NAMELIST /TYPE_3/       M

!-----------------------------------------------------------------------

  NT       = -1
  W0      = 6.
  TB      = -9999.
  TE      = -9999.
  KNFFT   = 15
  PCOI    = EXP(-2.)
  FMIN    = -1.
  FMAX    = -1.
  NF   = 500

  K1 = .TRUE.
  K2 = .FALSE.
  K3 = .FALSE.
  K4 = .TRUE.
  KEY_LOG =.FALSE.

  OPEN ( 10, FILE="HFRCWT", STATUS="OLD" )
  READ ( 10, NML=CONTROL_DATA )
  
  IF ( NT < 0 ) THEN
    print *, ' The value of parameter "NT" (number of samples) '
    print *, ' in the file "HFRCWT" is missing !!! '
    STOP
  ENDIF
  IF ( TB < -9000. ) THEN
    TB = 0.
    TE = (NT-1)*DT
  END IF

  IF ( TE < -9000. ) THEN
    TE = TB + (NT-1)*DT
  END IF

  IF ( NINT((TE-TB)/DT)+1 /= NT ) THEN
    print *, ' TE has to be equal to TB + (NT-1)*DT !!! '
    STOP
  END IF

  IF ( FMAX < 0. ) THEN
    FMAX = 0.5/DT
  END IF

  IF ( FMIN .LE. 0. ) THEN
    IF ( KEY_LOG ) THEN
      FMIN = FMAX/1000.
    ELSE
      FMIN = 0.
    END IF
  END IF

  NFFT   = 2**KNFFT
  NFFT21 = NFFT/2 + 1


  SELECT CASE ( WVLT_TYPE )     
    CASE (1)
      READ ( 10, NML=TYPE_1 )   
    CASE (2)
      READ ( 10, NML=TYPE_2 )   
      IF  ( K1.OR.K2.OR.K3) THEN
        print *, ' This program computes reassignment method for CWT with Morlet wavelet only '
        print *, ' (not with Paul wavelet).'
        print *, ' Time-frequency representation using CWT with Paul wavelet will be computed.'
      ENDIF  
    CASE (3)
      READ ( 10, NML=TYPE_3 )
      IF  ( K1.OR.K2.OR.K3) THEN
        print *, ' This program computes reassignment method for CWT with Morlet wavelet only '
        print *, ' (not with DOG wavelet).'
        print *, ' Time-frequency representation using CWT with DOG wavelet will be computed.'
      ENDIF
    END SELECT                    

  CLOSE ( 10 )

  OUTo_FILE = INP_FILE (1:LEN_TRIM(INP_FILE))//'o.GRD'
  OUTt_FILE = INP_FILE (1:LEN_TRIM(INP_FILE))//'t.GRD'
  OUTf_FILE = INP_FILE (1:LEN_TRIM(INP_FILE))//'f.GRD'
  OUTr_FILE = INP_FILE (1:LEN_TRIM(INP_FILE))//'r.GRD'
  INP_FILE  = INP_FILE (1:LEN_TRIM(INP_FILE))//'.DAT'

  ALLOCATE ( V(1:NT), WV(1:NT+1,1:NF), WVD(1:NT+1,1:NF),                &
             WVT(1:NT+1,1:NF), F_V(NFFT), FWV (NFFT), FPWV (NFFT),      & 
             TTT(1:NT  ,1:NF), FFF(1:NT ,1:NF)    ) 
  
  N     = NT
  OFMAX = NF

END SUBROUTINE READ_INP_PARAM

