PROGRAM RWFT

USE GLOBAL, ONLY : WTW, WP, WV, WVT, WVD, TTT, FFF, N, F_V, K1, K2, K3

  IMPLICIT NONE

!---------------------------------------------------------------------------

  INTERFACE

    SUBROUTINE     WFT  (TWV)
      USE GLOBAL, ONLY: WP
      IMPLICIT NONE
	    COMPLEX(WP), DIMENSION(:,:), INTENT(INOUT) :: TWV
  	END SUBROUTINE WFT

    SUBROUTINE     WFTT (TWV)
      USE GLOBAL, ONLY: WP
      IMPLICIT NONE
      COMPLEX(WP), DIMENSION(:,:), INTENT(INOUT) :: TWV
    END SUBROUTINE WFTT

  END INTERFACE

!--------------------------------------------------------------------
  
  CALL READ_INP_PARAM 
  CALL READ_INP_DATA
  CALL WRITE_PAR  

  CALL PREP_WINDOW
  CALL WFT  (WV )

  IF ( K1 .OR. K2 .OR. K3 ) THEN
    CALL PREP_WINDOW
    CALL WFTT (WVT)

    CALL PREP_WINDOW_D
    CALL WFT  (WVD)


    WHERE ( ABS(WV) > 0. )  
      TTT = REAL ( WVT(1:N,:) / WV (1:N,:) )
      FFF = REAL ( WVD(1:N,:) / WV (1:N,:) )
    ELSEWHERE
      TTT = 0.
      FFF = 0.
    END WHERE
  END IF

  CALL WRITE_RES

END PROGRAM RWFT
