SUBROUTINE WFT (TWV)

  USE GLOBAL, ONLY: WP, F_V, OFMAX, NTW2, NTW, N, V, DT, NFFT, FWV,    &
                    KEY_LOG, DF_LOG, FMINLOG, FMIN, KNFFT

  IMPLICIT NONE

  INTEGER     :: I, J, JC

  REAL   (WP) :: F

  COMPLEX(WP), DIMENSION(:,:), INTENT(INOUT) :: TWV

! -----------------------------------------------

  DO I = NTW2+1, N-NTW2

    FWV = CMPLX(0.,KIND=WP)
    DO J = 1, NTW
      FWV(J) = CMPLX(V(I+J-NTW2-1),KIND=WP)
    END DO
    FWV = FWV * F_V

    CALL FCOOLR ( KNFFT, FWV, -1._WP )

    IF ( KEY_LOG ) THEN
      DO J = 1, OFMAX
        F        = 10** ( DF_LOG*(J-1) + FMINLOG )
        JC       = NINT(F*NFFT*DT) + 2
        TWV(I,J) = FWV(JC)*DT
      END DO
    ELSE
      JC = NINT(FMIN*NFFT*DT)+2
      TWV(I,1:OFMAX) = FWV(JC:OFMAX-1+JC)*DT
    END IF

  END DO

  TWV(N+1,:) = CMPLX ( NTW2, 0. )

END SUBROUTINE WFT