SUBROUTINE BMP( INPUT, BMP_FILE, DES_FILE )

USE MOD_BMP, ONLY : B4_B, B2_B, U_BYTE, SET_PALETTE, B_B4

!-----------------------------------------------------------------------

IMPLICIT NONE

INTEGER, DIMENSION(:,:) :: INPUT
CHARACTER*15            :: BMP_FILE
CHARACTER*12            :: DES_FILE

INTEGER(4)              :: I4, MOD4, M, N, I, J, F_SIZE, F_POS, REC, B(4)
INTEGER(2)              :: I2, PALETTE(256,4)

INTEGER(2), ALLOCATABLE :: FILE(:)

!-----------------------------------------------------------------------

M=SIZE( INPUT(:,1) )
N=SIZE( INPUT(1,:) )

IF ( MOD(M,4)==0 ) THEN
  F_SIZE = 14+40+4*256+N*M
ELSE
  F_SIZE = 14+40+4*256+N*M+N*(4-MOD(M,4))
END IF

IF ( MOD(F_SIZE,4)/=0 ) THEN
  F_SIZE = F_SIZE+4-MOD(F_SIZE,4)
END IF

ALLOCATE( FILE(F_SIZE) )

FILE = 0

!--- HLAVICKA 'BM'
I2 = 19778
FILE(1:2) = B2_B(I2) 

!--- VELKOST SUBORU
I4=F_SIZE
FILE(3:6) = B4_B(I4) 

!--- RESERV.
I4=0
FILE(7:10) = B4_B(I4) 

!--- OFFSET KU RASTRU
I4=1078
FILE(11:14) = B4_B(I4) 

!--- VELKOST INFO HLAVICKY
I4=40
FILE(15:18) = B4_B(I4) 

!--- SIRKA OBRAZKA V PIXELOCH
I4=M
FILE(19:22) = B4_B(I4) 

!--- VYSKA OBR. V PIXELOCH
I4=N
FILE(23:26) = B4_B(I4) 

!--- POCET ROVIN
I2=1
FILE(27:28) = B2_B(I2) 

!--- POCET BITOV NA PIXEL
I2=8 ! = 256 FARIEB
FILE(29:30) = B2_B(I2) 

!--- KOMPRESIA
I4=0 ! BEZ KOMPRESIE
FILE(31:34) = B4_B(I4) 

!--- VELKOST SKOMPRIMOVANEHO OBR.
I4=0 ! BEZ KOMPRESIE
FILE(35:38) = B4_B(I4) 

!--- PIXELOV NA M V SMERE X
I4=0 
FILE(39:42) = B4_B(I4) 

!--- PIXELOV NA M V SMERE Y
I4=0 
FILE(43:46) = B4_B(I4) 

!--- POCET FARIEB
I4=256
FILE(47:50) = B4_B(I4) 

!--- POCET DOLEZITZCH FARIEB
I4=0 ! = VSETKY
FILE(51:54) = B4_B(I4) 

!--- PALETA

CALL SET_PALETTE( DES_FILE, PALETTE )

F_POS = 55

DO I4 = 1, 256
  
  FILE(F_POS  ) = PALETTE(I4,1)
  FILE(F_POS+1) = PALETTE(I4,2)
  FILE(F_POS+2) = PALETTE(I4,3)
  FILE(F_POS+3) = PALETTE(I4,4)

  F_POS = F_POS + 4

END DO

!--- RASTER

MOD4 = MOD(M,4)

DO J = N, 1, -1

  DO I = 1, M
    FILE(F_POS) = INPUT(I,J)
    F_POS = F_POS+1
  END DO

  IF (MOD4>0) THEN
    DO I=1, 4-MOD4
      FILE(F_POS) = 0
      F_POS = F_POS+1
    END DO
  END IF

END DO
 
INQUIRE( IOLENGTH = REC ) I4
OPEN( 10, FILE=BMP_FILE, FORM='UNFORMATTED', ACCESS='DIRECT', RECL = REC )

  DO I=1,INT( F_SIZE / 4. )

    J  = 1+(I-1)*4

    B(1) = FILE(J)
    B(2) = FILE(J+1)
    B(3) = FILE(J+2)
    B(4) = FILE(J+3)

    I4 = B_B4( B(1), B(2), B(3), B(4) )
!    I4 = B_B4( B(4), B(3), B(2), B(1) )
    
    WRITE( 10, REC=I ) I4

  END DO

CLOSE(10)

END
