SUBROUTINE SET_PALETTE( DES_FILE, PALETTE )

!-----------------------------------------------------------------------

IMPLICIT NONE

CHARACTER(*), INTENT(IN) :: DES_FILE
INTEGER(2)  , INTENT(OUT) :: PALETTE(256,4)

INTEGER :: N_COLORS, N_INT, I, COL
					  
REAL    :: K_R, K_G, K_B, Q_R, Q_G, Q_B,                               &
					 START_C, START_R, START_G, START_B,                         &
					  STOP_C,  STOP_R,  STOP_G,  STOP_B	

!-----------------------------------------------------------------------

PALETTE(:,1) = 0
PALETTE(:,2) = 0
PALETTE(:,3) = 0
PALETTE(:,4) = 0

OPEN( 11, FILE=DES_FILE )

READ( 11,* )N_COLORS, N_INT

DO I = 1, N_INT
	
	READ(11,*) START_C, START_R, START_G, START_B
	READ(11,*) STOP_C,   STOP_R,  STOP_G,  STOP_B
	
	K_R = ( STOP_R - START_R )/( STOP_C - START_C )
	Q_R = ( STOP_C*START_R - START_C*STOP_R )/( STOP_C - START_C )
	
	K_G = ( STOP_G - START_G )/( STOP_C - START_C )
	Q_G = ( STOP_C*START_G - START_C*STOP_G )/( STOP_C - START_C )

	K_B = ( STOP_B - START_B )/( STOP_C - START_C )
	Q_B = ( STOP_C*START_B - START_C*STOP_B )/( STOP_C - START_C )

	DO COL = START_C, STOP_C-1
		
		!R
		PALETTE(COL+1,3) = INT( K_R * COL + Q_R )
		!G
		PALETTE(COL+1,2) = INT( K_G * COL + Q_G )
		!B
		PALETTE(COL+1,1) = INT( K_B * COL + Q_B )

	END DO

END DO

PALETTE( N_COLORS+1, 3) = INT(STOP_R)
PALETTE( N_COLORS+1, 2) = INT(STOP_G)
PALETTE( N_COLORS+1, 1) = INT(STOP_B)

CLOSE( 11 )

END