SUBROUTINE SETTINGS ( COMMENT, KEY_VIEW, KEY_INTER, KEY_MAX, MAG,          &
                      KEY_GRID, KEY_SAVE, DES_FILE, MAXSC, GLMAX,      &
                      NDT, NDDT, TMINTIC, DTTICS, TMIN, TMAX,          &
                      NDF, NDDF, FMINTIC, DFTICS, FMIN, FMAX, KEY_LOG )

! OUTPUT ACTUAL SETTINGS FOR DISPLAY OF TFA TO "ACTUAL SETTINGS WINDOW" 

USE PRECISION, ONLY: WP
USE DFLIB

!----------------------------------------------------------------------

IMPLICIT NONE

  CHARACTER (LEN=*) , INTENT(IN)  :: DES_FILE, COMMENT

  LOGICAL,            INTENT(IN)  :: KEY_VIEW, KEY_GRID, KEY_MAX,      &
                                     KEY_INTER, KEY_SAVE, KEY_LOG
  INTEGER,            INTENT(IN)  :: NDT, NDDT, NDF, NDDF
  REAL(WP),           INTENT(IN)  :: MAG, MAXSC,GLMAX, TMIN, TMAX,     &
                                     TMINTIC, FMINTIC, DTTICS, DFTICS, &
                                     FMIN, FMAX

  INTEGER(4)         :: RES
  CHARACTER (LEN=80) :: OUTCH

  TYPE(WINDOWCONFIG) :: WC     
  TYPE(QWINFO)       :: WINFO
  TYPE(RCCOORD)      :: RC

!----------------------------------------------------------------------
!(#00FFFFC6)           ! svetlo-modra

  RES = SETACTIVEQQ(19)
  RES = FOCUSQQ(19)
  CALL CLEARSCREEN($GWINDOW)
!---------------------------------
  RES = SETTEXTCOLORRGB(#00FFFF00)           ! zeleno-modra
  CALL SETTEXTPOSITION (INT2(1), INT2(1), RC)
  CALL OUTTEXT('COMMENT: ')
  CALL SETTEXTPOSITION (INT2(1), INT2(10), RC)
  RES = SETTEXTCOLORRGB(#00A3CF96)           ! svetlo-modra
  WRITE (OUTCH,'(A80)') COMMENT
  CALL OUTTEXT(OUTCH)
!---------------------------------
  RES = SETTEXTCOLORRGB(#00C0C0C0)           ! biela (tlmena)
  CALL SETTEXTPOSITION (INT2(3), INT2(7), RC)
  CALL OUTTEXT('TMIN =')
  RES = SETTEXTCOLORRGB(#00FFFFFF)           ! biela (jasna)
  WRITE (OUTCH,'(F9.2)') TMIN
  CALL OUTTEXT(OUTCH)
!---------------------------------
  RES = SETTEXTCOLORRGB(#00C0C0C0)           ! biela (tlmena)
  CALL SETTEXTPOSITION (INT2(3), INT2(22), RC)
  CALL OUTTEXT('s  TMAX =')
  RES = SETTEXTCOLORRGB(#00FFFFFF)           ! biela (jasna)
  WRITE (OUTCH,'(F9.2)') TMAX
  CALL OUTTEXT(OUTCH)
!---------------------------------
  RES = SETTEXTCOLORRGB(#00C0C0C0)           ! biela (tlmena)
  CALL SETTEXTPOSITION (INT2(3), INT2(40), RC)
  CALL OUTTEXT('s      FMIN = ')
  RES = SETTEXTCOLORRGB(#00FFFFFF)           ! biela (jasna)
  WRITE (OUTCH,'(F7.3)') FMIN
  CALL OUTTEXT(OUTCH)
!---------------------------------
  RES = SETTEXTCOLORRGB(#00C0C0C0)           ! biela (tlmena)
  CALL SETTEXTPOSITION (INT2(3), INT2(61), RC)
  CALL OUTTEXT(' Hz     FMAX = ')
  RES = SETTEXTCOLORRGB(#00FFFFFF)           ! biela (jasna)
  WRITE (OUTCH,'(F7.3)') FMAX
  CALL OUTTEXT(OUTCH)
  CALL SETTEXTPOSITION (INT2(3), INT2(83), RC)
  RES = SETTEXTCOLORRGB(#00C0C0C0)           ! biela (tlmena)
  CALL OUTTEXT(' Hz')
!---------------------------------
  CALL SETTEXTPOSITION (INT2(4), INT2(7), RC)
  CALL OUTTEXT('VIEW:')
  IF (KEY_VIEW) THEN
    WRITE (OUTCH,'(A)') ' on'
  ELSE
    WRITE (OUTCH,'(A)') ' off'
  ENDIF
  RES = SETTEXTCOLORRGB(#00FFFFFF)           ! biela (jasna)
  CALL OUTTEXT(OUTCH)
!---------------------------------
  RES = SETTEXTCOLORRGB(#00C0C0C0)           ! biela (tlmena)
  CALL SETTEXTPOSITION (INT2(4), INT2(25), RC)
  CALL OUTTEXT('INTERPOLATE:')
  IF (KEY_INTER) THEN
    WRITE (OUTCH,'(A)') ' on'
  ELSE
    WRITE (OUTCH,'(A)') ' off'
  ENDIF
  RES = SETTEXTCOLORRGB(#00FFFFFF)           ! biela (jasna)
  CALL OUTTEXT(OUTCH)
!---------------------------------
  RES = SETTEXTCOLORRGB(#00C0C0C0)           ! biela (tlmena)
  CALL SETTEXTPOSITION (INT2(4), INT2(47), RC)
  CALL OUTTEXT('SCALE: ')
  WRITE (OUTCH,'(A12)') DES_FILE
  RES = SETTEXTCOLORRGB(#00FFFFFF)           ! biela (jasna)
  CALL OUTTEXT(OUTCH)
!---------------------------------
  RES = SETTEXTCOLORRGB(#00C0C0C0)           ! biela (tlmena)
  CALL SETTEXTPOSITION (INT2(4), INT2(68), RC)
  CALL OUTTEXT('COLOR_SCALING:')
  IF ( MAXSC < 0.) THEN
    WRITE (OUTCH,'(A)') ' local'
  ELSEIF (ABS((MAXSC-GLMAX)/MAXSC) < 0.01) THEN
    WRITE (OUTCH,'(A)') ' global'
  ELSE
    WRITE (OUTCH,'(A)') ' fixed' 
  END IF
  RES = SETTEXTCOLORRGB(#00FFFFFF)           ! biela (jasna)
  CALL OUTTEXT(OUTCH)
!---------------------------------
  RES = SETTEXTCOLORRGB(#00C0C0C0)           ! biela (tlmena)
  CALL SETTEXTPOSITION (INT2(5), INT2(7), RC)
  CALL OUTTEXT('GRID:')
  IF (KEY_GRID) THEN
    WRITE (OUTCH,'(A)') ' on'
  ELSE
    WRITE (OUTCH,'(A)') ' off'
  ENDIF
  RES = SETTEXTCOLORRGB(#00FFFFFF)           ! biela (jasna)
  CALL OUTTEXT(OUTCH)
!---------------------------------
  RES = SETTEXTCOLORRGB(#00C0C0C0)           ! biela (tlmena)
  CALL SETTEXTPOSITION (INT2(5), INT2(25), RC)
  CALL OUTTEXT('FREQ_AXIS:')
  IF (KEY_LOG) THEN
    WRITE (OUTCH,'(A)') ' log'
  ELSE
    WRITE (OUTCH,'(A)') ' lin'
  ENDIF
  RES = SETTEXTCOLORRGB(#00FFFFFF)           ! biela (jasna)
  CALL OUTTEXT(OUTCH)
!---------------------------------
  RES = SETTEXTCOLORRGB(#00C0C0C0)           ! biela (tlmena)
  CALL SETTEXTPOSITION (INT2(5), INT2(47), RC)
  CALL OUTTEXT('RIDGES:')
  IF (KEY_MAX) THEN
    WRITE (OUTCH,'(A)') ' on'
  ELSE
    WRITE (OUTCH,'(A)') ' off'
  ENDIF
  RES = SETTEXTCOLORRGB(#00FFFFFF)           ! biela (jasna)
  CALL OUTTEXT(OUTCH)
!---------------------------------
  RES = SETTEXTCOLORRGB(#00C0C0C0)           ! biela (tlmena)
  CALL SETTEXTPOSITION (INT2(5), INT2(68), RC)
  CALL OUTTEXT('MAGNIFICATION: ')
  WRITE (OUTCH,'(F4.2)') MAG
  RES = SETTEXTCOLORRGB(#00FFFFFF)           ! biela (jasna)
  CALL OUTTEXT(OUTCH)
!---------------------------------
  RES = SETTEXTCOLORRGB(#00FFFF00)           ! modro-zelena
  CALL SETTEXTPOSITION (INT2(7), INT2(1), RC)
  CALL OUTTEXT('AXIS: ')
  CALL SETTEXTPOSITION (INT2(7), INT2(17), RC)
  RES = SETTEXTCOLORRGB(#00FF8080)           ! svetlo-modra
  CALL OUTTEXT(' (digits)')
  CALL SETTEXTPOSITION (INT2(7), INT2(60), RC)
  CALL OUTTEXT(' (tics)')
!---------------------------------
  CALL SETTEXTPOSITION (INT2(8), INT2(1), RC)
  CALL OUTTEXT('TIME |')
  RES = SETTEXTCOLORRGB(#00C0C0C0)           ! biela (tlmena)
  CALL OUTTEXT('    NDT = ')
  WRITE (OUTCH,'(I8)') NDT
  RES = SETTEXTCOLORRGB(#00FFFFFF)           ! biela (jasna)
  CALL OUTTEXT(OUTCH)
!---------------------------------
  RES = SETTEXTCOLORRGB(#00C0C0C0)           ! biela (tlmena)
  CALL SETTEXTPOSITION (INT2(8), INT2(29), RC)
  CALL OUTTEXT('NDDT = ')
  WRITE (OUTCH,'(I2)') NDDT
  RES = SETTEXTCOLORRGB(#00FFFFFF)           ! biela (jasna)
  CALL OUTTEXT(OUTCH)
!---------------------------------
  RES = SETTEXTCOLORRGB(#00C0C0C0)           ! biela (tlmena)
  CALL SETTEXTPOSITION (INT2(8), INT2(47), RC)
  CALL OUTTEXT('TMINTIC = ')
  WRITE (OUTCH,'(F8.2)') TMINTIC
  RES = SETTEXTCOLORRGB(#00FFFFFF)           ! biela (jasna)
  CALL OUTTEXT(OUTCH)
!---------------------------------
  RES = SETTEXTCOLORRGB(#00C0C0C0)           ! biela (tlmena)
  CALL SETTEXTPOSITION (INT2(8), INT2(68), RC)
  CALL OUTTEXT('DTTICS = ')
  WRITE (OUTCH,'(F8.3)') DTTICS
  RES = SETTEXTCOLORRGB(#00FFFFFF)           ! biela (jasna)
  CALL OUTTEXT(OUTCH)
!---------------------------------
  RES = SETTEXTCOLORRGB(#00FF8080)           ! svetlo-modra
  CALL SETTEXTPOSITION (INT2(9), INT2(1), RC)
  CALL OUTTEXT('FREQ |')
  RES = SETTEXTCOLORRGB(#00C0C0C0)           ! biela (tlmena)
  CALL OUTTEXT('    NDF = ')
  RES = SETTEXTCOLORRGB(#00FFFFFF)           ! biela (jasna)
  IF (KEY_LOG) THEN
    CALL OUTTEXT('automat.')
  ELSE
    WRITE (OUTCH,'(I8)') NDF
    CALL OUTTEXT(OUTCH)
  ENDIF
!---------------------------------
  RES = SETTEXTCOLORRGB(#00C0C0C0)           ! biela (tlmena)
  CALL SETTEXTPOSITION (INT2(9), INT2(29), RC)
  CALL OUTTEXT('NDDF = ')
  RES = SETTEXTCOLORRGB(#00FFFFFF)           ! biela (jasna)
  IF (KEY_LOG) THEN
    CALL OUTTEXT('automat.')
  ELSE
    WRITE (OUTCH,'(I2)') NDDF
    CALL OUTTEXT(OUTCH)
  ENDIF
!---------------------------------
  IF (KEY_LOG) THEN

    RES = SETTEXTCOLORRGB(#00C0C0C0)           ! biela (tlmena)
    CALL SETTEXTPOSITION (INT2(9), INT2(47), RC)
    CALL OUTTEXT('FMINTIC = ')
    RES = SETTEXTCOLORRGB(#00FFFFFF)           ! biela (jasna)
    CALL OUTTEXT('automat.')

    RES = SETTEXTCOLORRGB(#00C0C0C0)           ! biela (tlmena)
    CALL SETTEXTPOSITION (INT2(9), INT2(68), RC)
    CALL OUTTEXT('DFTICS = ')
    RES = SETTEXTCOLORRGB(#00FFFFFF)           ! biela (jasna)
    CALL OUTTEXT('automat.')

  ELSE

    RES = SETTEXTCOLORRGB(#00C0C0C0)           ! biela (tlmena)
    CALL SETTEXTPOSITION (INT2(9), INT2(47), RC)
    CALL OUTTEXT('FMINTIC = ')
    WRITE (OUTCH,'(F8.2)') FMINTIC
    RES = SETTEXTCOLORRGB(#00FFFFFF)           ! biela (jasna)
    CALL OUTTEXT(OUTCH)

    RES = SETTEXTCOLORRGB(#00C0C0C0)           ! biela (tlmena)
    CALL SETTEXTPOSITION (INT2(9), INT2(68), RC)
    CALL OUTTEXT('DFTICS = ')
    WRITE (OUTCH,'(F8.3)') DFTICS
    RES = SETTEXTCOLORRGB(#00FFFFFF)           ! biela (jasna)
    CALL OUTTEXT(OUTCH)
 
  ENDIF
!---------------------------------

END SUBROUTINE SETTINGS