SUBROUTINE TSFVIEW ( U, DAT, KEY_SQ, KEY_INTER, FMIN, FMAX, TMIN, TMAX,&
                     MTMIN, MTMAX, MFMIN, MFMAX,                       &
                     MAG, MAXSC, KEY_LOG, KEY_GRID, KEY_MAX, WW,       &
                     KEY_SUMT,                                         &
                     DES_FILE, NUM_COLS, CG, SAVEBMP,                  &
                     TMINTIC, DTTICS, FMINTIC, DFTICS,                 &
                     NDT, NDDT, NDF, NDDF )

USE PRECISION, ONLY: WP, GP
USE DFLIB
USE MOD_BMP  , ONLY: BMP

!----------------------------------------------------------------------

IMPLICIT NONE

  CHARACTER (LEN=*) , INTENT(IN)  :: DES_FILE, SAVEBMP

  LOGICAL,            INTENT(IN)  :: KEY_SQ, KEY_GRID, KEY_MAX,        &
                                     KEY_LOG, KEY_INTER, KEY_SUMT
  INTEGER,            INTENT(IN)  :: MTMIN, MTMAX, MFMIN, MFMAX,       &
                                     NDT, NDDT, NDF, NDDF,             &
                                     NUM_COLS
  REAL(WP),           INTENT(IN)  :: FMIN, FMAX, TMIN, TMAX, MAG,      &
                                     TMINTIC, FMINTIC, DTTICS, DFTICS, &
                                     CG, MAXSC, WW

  REAL(WP), DIMENSION(:)  , INTENT(INOUT) :: DAT
  REAL(WP), DIMENSION(:,:), INTENT(INOUT) :: U

!----------------------------------------------------------------------

  CHARACTER (LEN=11) :: TLBUF, FORM

  LOGICAL(2) :: INVERT, STATUS
  LOGICAL(4) :: RES, EX

  INTEGER    :: MTALL, MT, MF, ID, IMIN, IMAX, LMIN, LMAX, ML1(1),     &
                COI, II, JJ, IN, LN, I, L, IN1, LN1, LL

  REAL(WP)   :: MAXDAT, MAXU, SCALE, TMP
  REAL(GP)   :: RMT, RMF, UPX, UPY, DOWNX, DOWNY,                      &
                DT, DF, WX, WY, YPOS, XPOS

  INTEGER , ALLOCATABLE, DIMENSION(:,:) :: BMPA
  REAL(WP), DIMENSION(MTMIN:MTMAX)      :: SDAT

  TYPE(WINDOWCONFIG) :: WC
  TYPE(QWINFO)       :: WINFO
  TYPE( XYCOORD)     :: WT
  TYPE(WXYCOORD)     :: POLOHA

!----------------------------------------------------------------------

  MTALL = UBOUND(U,1)
  MT = MTMAX - MTMIN
  MF = MFMAX - MFMIN

  RMT = REAL(MT,GP)
  RMF = REAL(MF,GP)

  DT = (TMAX-TMIN)/RMT
  IF ( KEY_LOG ) THEN
    DF = LOG10(FMAX/FMIN) / RMF
  ELSE
    DF =      (FMAX-FMIN) / RMF
  END IF

  WINFO.H        =  800*MAG
  WINFO.W        = 1100*MAG
  WINFO.X        = 0
  WINFO.Y        = 0
  WINFO.TYPE     = QWIN$SET
  RES = SETWSIZEQQ (55,WINFO)
  RES = SETACTIVEQQ(55)
  RES = PASSDIRKEYSQQ(.TRUE.)

  wc.numxpixels  = 1100*MAG
  wc.numypixels  =  800*MAG
  wc.numtextcols = -1
  wc.numtextrows = -1
  wc.numcolors   = -1
  wc.title       = "T-F Diagram"C
  wc.fontsize    = #0006000C
  RES = SETWINDOWCONFIG(WC)
  IF ( .NOT.(RES) ) RES = SETWINDOWCONFIG(WC)

  CALL SETVIEWPORT(0,0,1099*MAG,799*MAG)

  INVERT = .TRUE.
  UPX   = -RMT*0.11
  UPY   =  RMF*1.1
  DOWNX =  RMT*1.24
  DOWNY = -RMF*0.5
  STATUS = SETWINDOW( INVERT, UPX, UPY, DOWNX, DOWNY)

  CALL GETVIEWCOORD_W (0._GP, RMF, WT)
  IMIN = WT%XCOORD
  LMIN = WT%YCOORD

  CALL GETVIEWCOORD_W (RMT, 0._GP, WT)
  IMAX = WT%XCOORD
  LMAX = WT%YCOORD

  ALLOCATE ( BMPA(IMAX-IMIN+1,LMAX-LMIN+1) )
  BMPA = 0

!----------------------------------------------------------------------

  RES = INITIALIZEFONTS()
  RES = SETFONT('t''Arial''h12w6pvb')

  IF ( MAXSC < 0. ) THEN
    MAXU = MAXVAL( U(MTMIN:MTMAX,MFMIN:MFMAX) )
    IF ( KEY_SQ ) MAXU = MAXU*MAXU
  ELSE
    MAXU = MAXSC
  END IF

!------- plot T-F diagram
  IF ( MAXU /= 0. ) THEN

    IF ( MAXU > 1.E-25 ) THEN
      SCALE = REAL(NUM_COLS)/MAXU
    ELSE
      SCALE = 0.
    END IF

    LN1 = LMAX-LMIN+1

    DO L = 0, MF
      IN1 = 1
      DO I = 0, MT
        TMP = U(I+MTMIN,L+MFMIN)
        IF ( KEY_SQ ) TMP = TMP*TMP
        ID = INT(SCALE*TMP)

        CALL GETVIEWCOORD_W (REAL(I,GP),REAL(L,GP), WT) 
        IN = WT%XCOORD-IMIN+1
        LN = WT%YCOORD-LMIN+1

        IF ( KEY_INTER ) THEN
          IF ( IN1 <= IN ) THEN
            IF ( LN <= LN1 ) THEN
              BMPA(IN1:IN,LN:LN1) = ID
            ELSE
              BMPA(IN1:IN,LN) = MAX( BMPA(IN1:IN,LN), ID )
            END IF
          ELSE
            IF ( LN <= LN1 ) THEN
              BMPA(IN,LN:LN1) = MAX( BMPA(IN,LN:LN1), ID )
            ELSE
              BMPA(IN,LN) = MAX( BMPA(IN,LN), ID )
            END IF
          END IF
        ELSE
          IF ( ( IN1 > IN ) .OR. ( LN > LN1 ) ) THEN
            BMPA(    IN,    LN) = MAX( BMPA(IN,LN), ID )
          ELSE
            BMPA(    IN,    LN) = ID
          END IF
        END IF
        IN1 = IN + 1
      END DO
      LN1 = LN - 1

!       ---- plot cone of influence
!      ID = INT(NUM_COLS-5,2)
      ID =  INT(NUM_COLS-123,2) !SETCOLORRGB(#000000)

      COI = INT ( U ( MTALL, L+MFMIN ) )        !!!!!!!! Odtialto DOCASNE VYPUSTENE VYKRESLOVANIE COI

      IF ( COI < MTALL/2 ) THEN
        IF      ( (       COI   < MTMAX ) .AND.                        &
                  (       COI   > MTMIN ) ) THEN
          CALL GETVIEWCOORD_W (REAL(      COI  -MTMIN,GP),REAL(L,GP),WT)
          IN = WT%XCOORD-IMIN+1
          LN = WT%YCOORD-LMIN+1
          BMPA(IN,LN) = ID
        END IF
        IF      ( ( MTALL-COI+1 < MTMAX ) .AND.                        &
                  ( MTALL-COI+1 > MTMIN ) ) THEN
          CALL GETVIEWCOORD_W (REAL(MTALL-COI+1-MTMIN,GP),REAL(L,GP),WT)
          IN = WT%XCOORD-IMIN+1
          LN = WT%YCOORD-LMIN+1
          BMPA(IN,LN) = ID
        END IF
      END IF                                    !!!!!!!! Potialto DOCASNE VYPUSTENE VYKRESLOVANIE COI

    END DO


    IF ( KEY_MAX ) THEN
      DO I = 0, MT
        ID = INT(NUM_COLS,2)
        ML1= MAXLOC(U(I+MTMIN,MFMIN:MFMAX))
        CALL GETVIEWCOORD_W (REAL(I,GP),REAL(ML1(1),GP), WT)
        IN = WT%XCOORD-IMIN+1
        LN = WT%YCOORD-LMIN+1
        BMPA(IN,LN) = ID
      END DO
    END IF

    CALL BMP( BMPA, 'TF.BMP', DES_FILE )

    CALL CLEARSCREEN($GCLEARSCREEN)

    RES = LOADIMAGE_W ( 'TF.BMP', REAL(0,GP),REAL(MF,GP))

  ELSE

    CALL CLEARSCREEN($GCLEARSCREEN)

  END IF

  ID = INT(NUM_COLS,2)
!  RES = SETCOLOR(ID)
  RES = SETCOLORRGB(#FFFFFF)

!------- plot time-axis tics (T-F diagram, bottom)

  YPOS = 0._GP
  CALL  MOVETO_W (0._GP, YPOS, POLOHA)
  RES = LINETO_W (RMT+1., YPOS        )

  DO I = NINT((TMINTIC-TMIN)/DT), MT+1, NINT(DTTICS/DT)
    WX = REAL(I,GP)
    CALL  MOVETO_W (WX, YPOS        , POLOHA)
    RES = LINETO_W (WX, YPOS-RMF/40.        )
  END DO

!------- plot time-axis tics (T-F diagram, top)

  YPOS = RMF
  CALL  MOVETO_W (0._GP, YPOS, POLOHA)
  RES = LINETO_W (RMT+1., YPOS        )

  DO I = NINT((TMINTIC-TMIN)/DT), MT+1, NINT(DTTICS/DT)
    WX = REAL(I,GP)
    CALL  MOVETO_W (WX, YPOS        , POLOHA)
    RES = LINETO_W (WX, YPOS+RMF/40.        )
  END DO

!------- plot freqency-axis tics (right)

  XPOS = RMT + 1.
  CALL  MOVETO_W (XPOS, 0._GP, POLOHA)
  RES = LINETO_W (XPOS, RMF          )

  IF ( KEY_LOG ) THEN
    DO L = NINT(LOG10(FMINTIC/FMIN)/DF), MF+1, NINT(1._WP/DF)
      DO LL = 1,9
        WY = REAL(L,GP)+NINT(LOG10(REAL(LL))/DF)
        IF ( ( WY <= REAL(MF,GP) ) .AND. ( WY >= 0._GP ) ) THEN
          CALL  MOVETO_W (XPOS+RMT/80., WY, POLOHA)
          RES = LINETO_W (XPOS        , WY        )
        END IF
      END DO
    END DO
  ELSE
    DO L = NINT((FMINTIC-FMIN)/DF), MF+1, NINT(DFTICS/DF)
      WY = REAL(L,GP)
      CALL  MOVETO_W (XPOS+RMT/80., WY, POLOHA)
      RES = LINETO_W (XPOS        , WY        )
    END DO
  END IF

!------- plot frequency-axis tics (left) and labels

  XPOS = 0._GP
  CALL  MOVETO_W (XPOS, 0._GP, POLOHA)
  RES = LINETO_W (XPOS, RMF          )

  IF ( KEY_LOG ) THEN
    DO L = NINT(LOG10(FMINTIC/FMIN)/DF), MF+1, NINT(1._WP/DF)
      DO LL = 1,9
        WY = REAL(L,GP)+NINT(LOG10(REAL(LL))/DF)
        IF ( ( WY <= MF ) .AND. ( WY >= 0 ) ) THEN
          CALL  MOVETO_W (XPOS-RMT/80., WY, POLOHA)
          RES = LINETO_W (XPOS        , WY        )
        END IF
        IF ( ( WY <= MF ) .AND. ( WY >= 0 ) ) THEN
          IF ( ( LL == 1 ) .OR. ( FMAX/FMIN < 10. ) ) THEN
            WRITE (TLBUF, '(E7.1)' ) (10**(WY*DF))*FMIN
            CALL MOVETO_W (-RMT*SQRT(14.)/40., WY+RMF*0.014, POLOHA)
            CALL OUTGTEXT(TLBUF)
          END IF
        END IF
      END DO
    END DO
  ELSE
    IF ( NDDF == 0 ) THEN
      WRITE ( FORM , '(A2, I1, A1)' ) '(I',NDF,')'
    ELSE
      WRITE ( FORM , '(A2, I1, A1, I1, A1)' ) '(F',NDF,'.',NDDF,')'
    END IF
    DO L = NINT((FMINTIC-FMIN)/DF), MF+1, NINT(DFTICS/DF)
      WY = REAL(L,GP)
      CALL  MOVETO_W (XPOS-RMT/80., WY, POLOHA)
      RES = LINETO_W (XPOS        , WY        )

      IF ( NDDF == 0 ) THEN
        WRITE (TLBUF,FORM) NINT( WY*DF+FMIN )
      ELSE
        WRITE (TLBUF,FORM) NINT((WY*DF+FMIN)*(10**NDDF))/REAL(10**NDDF)
      END IF
      CALL MOVETO_W (-RMT*SQRT(REAL(NDF))/40., WY+RMF*0.014, POLOHA)
      CALL OUTGTEXT(TLBUF)
    END DO
  END IF

  CALL MOVETO_W (-RMT*0.1, RMF*0.414, POLOHA)
  CALL OUTGTEXT('f [Hz]')

!------- plot grid

  IF ( KEY_GRID ) THEN
    ID = INT(NUM_COLS*CG,2)
    RES = SETCOLOR(ID)

    YPOS = RMF 
    DO I = NINT((TMINTIC-TMIN)/DT), MT+1, NINT(DTTICS/DT)
      WX = REAL(I,GP)
      IF ( (I /= 0.) .AND. (I /= MT+1)) THEN
        CALL  MOVETO_W (WX, YPOS , POLOHA)
        RES = LINETO_W (WX, 1._GP        )
      END IF
    END DO

    XPOS = RMT
    IF ( KEY_LOG ) THEN
      DO L = NINT(LOG10(FMINTIC/FMIN)/DF)+NINT(1._WP/DF), MF, NINT(1._WP/DF)
        WY = REAL(L,GP)
        IF ( (L /= 0.) .AND. (L /= MF)) THEN
          CALL  MOVETO_W (XPOS , WY, POLOHA)
          RES = LINETO_W (1._GP, WY        )
        END IF
      END DO
    ELSE
      DO L = NINT((FMINTIC-FMIN)/DF), MF, NINT(DFTICS/DF)
        WY = REAL(L,GP)
        IF ( (L /= 0.) .AND. (L /= MF)) THEN
          CALL  MOVETO_W (XPOS , WY, POLOHA)
          RES = LINETO_W (1._GP, WY        )
        END IF
      END DO
    END IF
  END IF

  IF ( KEY_SUMT ) THEN
!------- plot sum time signal

    DO I = MTMIN, MTMAX
      SDAT(I) = SUM(U(I,MFMIN:MFMAX))/REAL(MFMAX-MFMIN+1)
    END DO

    MAXDAT = MAXVAL(ABS(SDAT(MTMIN:MTMAX))) / RMF*13.

!  RES = SETCOLOR(ID)
    RES = SETCOLORRGB(#0000FF)

    DO I = 1, MT
      WX = REAL(I,GP)
      CALL  MOVETO_W (WX-1., -RMF/6.+SDAT(I-1+MTMIN)/MAXDAT, POLOHA)
      RES = LINETO_W (WX   , -RMF/6.+SDAT(I  +MTMIN)/MAXDAT        )
    END DO

    RES = SETFONT('t''Arial''h8w4pvb')

    WRITE ( TLBUF,'(E10.3E1)' )  MAXDAT*RMF/13
    WX = REAL(MT)
    CALL MOVETO_W (WX+RMT*0.1, -RMF/6.+RMF/13.+RMF*0.014, POLOHA)
    CALL OUTGTEXT(TLBUF)

  END IF

!------- plot analysed input signal

  MAXDAT = MAXVAL(ABS(DAT(MTMIN:MTMAX))) / RMF*13.

  ID = INT(NUM_COLS,2)
!  RES = SETCOLOR(ID)
  RES = SETCOLORRGB(#FFFFFF)

  DO I = 1, MT
    WX = REAL(I,GP)
    CALL  MOVETO_W (WX-1., -RMF/6.+DAT(I-1+MTMIN)/MAXDAT, POLOHA)
    RES = LINETO_W (WX   , -RMF/6.+DAT(I  +MTMIN)/MAXDAT        )
  END DO

  RES = SETFONT('t''Arial''h8w4pvb')

!------- plot y-axis (analysed signal) tics and labels

  CALL  MOVETO_W (0._GP, -RMF/6.-RMF/13., POLOHA)
  RES = LINETO_W (0._GP, -RMF/6.+RMF/13.        )
  DO I = -1, 1
    CALL  MOVETO_W (-RMT*0.01, -RMF/6.+I*RMF/13., POLOHA)
    RES = LINETO_W (0._GP    , -RMF/6.+I*RMF/13.        )
    WRITE ( TLBUF,'(E10.3E1)' )  REAL(I)*MAXDAT*RMF/13
    CALL MOVETO_W (-RMT*0.1, -RMF/6.+I*RMF/13.+RMF*0.014, POLOHA)
    CALL OUTGTEXT(TLBUF)
  END DO

  RES = SETFONT('t''Arial''h12w6pvb')

!------- plot time-axis (analysed signal) tics and labels
  YPOS = -RMF/3.3
  CALL  MOVETO_W (0._GP, YPOS, POLOHA)
  RES = LINETO_W (RMT  , YPOS        )
  IF ( NDDT == 0 ) THEN
    WRITE ( FORM , '(A2, I1, A1)' ) '(I',NDT,')'
  ELSE
    WRITE ( FORM , '(A2,I1,A1,I1,A1)' ) '(F',NDT,'.',NDDT,')'
  END IF

  DO I = NINT((TMINTIC-TMIN)/DT), MT+1, NINT(DTTICS/DT)
    WX = REAL(I,GP)
    CALL  MOVETO_W (WX, YPOS        , POLOHA)
    RES = LINETO_W (WX, YPOS-RMF/40.        )
    IF ( NDDT == 0 ) THEN
      WRITE (TLBUF,FORM) NINT( WX*DT+TMIN )
    ELSE
      WRITE (TLBUF,FORM) NINT((WX*DT+TMIN)*(10**NDDT))/REAL(10**NDDT)
    END IF
    CALL MOVETO_W (WX-RMT*REAL(NDT)/200., YPOS-RMF/30., POLOHA)
    CALL OUTGTEXT(TLBUF)
  END DO

  CALL MOVETO_W (RMT*1.04, YPOS-RMF/30., POLOHA)
  CALL OUTGTEXT('s')

!------- plot window-width bar

  IF ( WW > 0. ) THEN
    ID = INT(NUM_COLS/2,2)
    RES = SETCOLOR(ID)

    CALL  MOVETO_W (0._GP          , -RMF/2.4        ,POLOHA)
    RES = LINETO_W (ANINT(WW/DT,GP), -RMF/2.4               )
    CALL  MOVETO_W (0._GP          , -RMF/2.4-RMF/40.,POLOHA)
    RES = LINETO_W (0._GP          , -RMF/2.4+RMF/40.       )
    CALL  MOVETO_W (ANINT(WW/DT,GP), -RMF/2.4-RMF/40.,POLOHA)
    RES = LINETO_W (ANINT(WW/DT,GP), -RMF/2.4+RMF/40.       )
    CALL  MOVETO_W (0._GP          , -RMF/2.2        ,POLOHA)
    WRITE ( TLBUF,'(F4.1, 1X, A1)' )  WW,'s'
    CALL OUTGTEXT(TLBUF)
  END IF

!------- plot scale

  INQUIRE (FILE='SCALE.BMP', EXIST = EX)
  IF ( .NOT.EX ) THEN
    DO I = 0, NUM_COLS
      ID = INT(I,2)
      RES = SETCOLOR(ID)
      DO II = 0, 20
        DO JJ = 0, 5
          RES=SETPIXEL_W(RMT*(1.05+II/1000.),RMF*(I+JJ/4.)/(NUM_COLS+1))
        END DO
      END DO
    END DO

    RES = SAVEIMAGE_W( 'SCALE.BMP', RMT* 1.05                 ,        &
                                    RMF*(NUM_COLS+5./4.)/(NUM_COLS+1), &
                                    RMT*(1.05+20./1000.),              &
                                         0._GP                 )
  ELSE
    RES = LOADIMAGE_W( 'SCALE.BMP', RMT*(1.05),                        &
                                    RMF*(NUM_COLS+5./4.)/(NUM_COLS+1) )
  END IF


  RES = SETCOLORRGB(#FFFFFF)

  DO I = 0, 5
    CALL  MOVETO_W (RMT*1.05, 0._GP   , POLOHA)
    RES = LINETO_W (RMT*1.05, RMF             )
    RES = LINETO_W (RMT*1.07, RMF             )
    RES = LINETO_W (RMT*1.07, 0._GP           )
    RES = LINETO_W (RMT*1.05, 0._GP           )
    CALL  MOVETO_W (RMT*1.07, I*RMF/5., POLOHA)
    RES = LINETO_W (RMT*1.08, I*RMF/5.        )
    WRITE ( TLBUF,'(E9.2)' )  MAXU/5.*I
    CALL MOVETO_W (RMT*1.09, I*RMF*0.2+RMF*0.014, POLOHA)
    CALL OUTGTEXT(TLBUF)
  END DO

!  save to the file

  RES = SAVEIMAGE_W(SAVEBMP, UPX, UPY, DOWNX, DOWNY)

!  CLOSE(55,STATUS='KEEP' )

END SUBROUTINE TSFVIEW

